Subject: Re: Summary of issues with the Java LDAP API and resolutions

From: "Steve Sonntag" <[email-masked]>
Date: Mon, 26 Mar 2001 10:46:57 -0700

The fact that the API must correct the scope when automatically
following referrals/references seems obvious to me, but the assertion
that the API must fix the scope for search references as described
below is not evident. I assumed from the I-D description that the referral
is handed to the application as it came off the wire, i.e. unchanged.

If it is the responsibility of the API to adjust the scope even when NOT doing
automatic referral following, then it should be stated explicitly in the I-D.

-Steve

>>> Rob Weltman <[email-masked]> 26-Mar-01 12:12:41 AM >>>
"Kurt D. Zeilenga" wrote:
> 
> At 03:38 PM 3/25/01 -0800, Rob Weltman wrote:
> > An application is always free to do its own LDAP URL parsing, and there will undoubtedly always be applications that choose to do so. But all applications that implement their own chasing of referrals do not need to distinguish between explicit URL parameters and implied URL parameters.
> 
> The scope defaulting is different for search referrals than for
> search continuations. In a referral, no explicit scope implies
> the client should reuse the prior scope. In a continuation, no
> explicit scope implies the client should use a base derived from
> the prior base (base->base, one->base, subtree->base).

 That has already been discussed on this list. The API implementation delivers the referral correctly rewritten so the client doesn't need to worry about it, regardless of if using automatic referral following or automatic referral following.

> >As a matter of fact, in the years I've worked with the Java LDAP API and applications that did their own referral processing, I haven't seen a single such case.
> 
> You'll find such a case detailed in RFC 2251 examples!

 The API we propose (and which has been is use for four years now) handles the rewriting of the scope exactly as per RFC 2251 so that there is no need for a client to do it.

Rob